#include "TeamStatistik.h"

// Inhalt der TeamStatistik Klasse aus TeamStatistik.h
// Konstruktor
TeamStatistik::TeamStatistik()
{
	teamNummer = 0;
	teamName = new Text();
	teamFarbe = 0;
	schadenBekommen = 0;
	schadenGemacht = 0;
	treibstoffVerbraucht = 0;
	shots = 0;
	treffer = 0;
	punkte = 0;
	kills = 0;
	tode = 0;
	gewonnen = 0;
	ref = 1;
}

// Destruktor
TeamStatistik::~TeamStatistik()
{
	teamName->release();
}

// nicht constant
void TeamStatistik::initValues( InitDatei *dat )
{
	if( dat->wertExistiert( "TeamNummer" ) )
		teamNummer = *dat->zWert( "TeamNummer" );
	if( dat->wertExistiert( "TeamName" ) )
		*teamName = dat->zWert( "TeamName" )->getText();
	if( dat->wertExistiert( "TeamFarbe" ) )
		teamFarbe = *dat->zWert( "TeamFarbe" );
	if( dat->wertExistiert( "SchadenBekommen" ) )
		schadenBekommen = *dat->zWert( "SchadenBekommen" );
	if( dat->wertExistiert( "SchadenGemacht" ) )
		schadenGemacht = *dat->zWert( "SchadenGemacht" );
	if( dat->wertExistiert( "TreibstoffVerbraucht" ) )
		treibstoffVerbraucht = *dat->zWert( "TreibstoffVerbraucht" );
	if( dat->wertExistiert( "Schüsse" ) )
		shots = *dat->zWert( "Schüsse" );
	if( dat->wertExistiert( "Treffer" ) )
		treffer = *dat->zWert( "Treffer" );
	if( dat->wertExistiert( "Punkte" ) )
		punkte = *dat->zWert( "Punkte" );
	if( dat->wertExistiert( "Kills" ) )
		kills = *dat->zWert( "Kills" );
	if( dat->wertExistiert( "Tode" ) )
		tode = *dat->zWert( "Tode" );
	if( dat->wertExistiert( "Gewonnen" ) )
		gewonnen = (int)*dat->zWert( "Tode" ) != 0;
	dat->release();
}

// constant
int TeamStatistik::getTeamNummer() const
{
	return teamNummer;
}

Text *TeamStatistik::getTeamName() const
{
	return teamName ? teamName->getThis() : 0;
}

Text *TeamStatistik::zTeamName() const
{
	return teamName;
}

int TeamStatistik::getTeamFarbe() const
{
	return teamFarbe;
}

int TeamStatistik::getSchadenBekommen() const
{
	return schadenBekommen;
}

int TeamStatistik::getSchadenGemacht() const
{
	return schadenGemacht;
}

int TeamStatistik::getTreibstoffVerbraucht() const
{
	return treibstoffVerbraucht;
}

int TeamStatistik::getShots() const
{
	return shots;
}

int TeamStatistik::getTreffer() const
{
	return treffer;
}

int TeamStatistik::getPunkte() const
{
	return punkte;
}

int TeamStatistik::getKills() const
{
	return kills;
}

int TeamStatistik::getTode() const
{
	return tode;
}

bool TeamStatistik::hatGewonnen() const
{
	return gewonnen;
}

// Reference Counting
TeamStatistik *TeamStatistik::getThis()
{
	ref++;
	return this;
}

TeamStatistik *TeamStatistik::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}